#include <mega8.h>    
#include <stdio.h>
#include <delay.h>
#include <String.h>   //      memcpy

//#define TRFreset    0   //  - ,    ,  
#define TRFSYNC     0   //  -  HEADER
#define TRFwait     2   //  -       
#define TRFError    3 
#define TRFError2    4   //  - 
#define TRFSkip     5   //  - 
#define TRFSkip2    6            

#define BGRX_Wait   0
#define BGRX_Run    1
#define BGRX_Zero   2
//#define BGRX_NoiseH 3
//#define BGRX_NoiseL 4

#define W           0
#define R           1

#define Cell_0      0
#define Cell_1      1
#define Cell_2      2

#define WrCell_0    0
#define WrCell_1    1
#define WrCell_2    2

#define TE           400        //

#define SHORT_HEAD   20         //   
#define LONG_HEAD    40         //   

#define NBIT         62     // number of bit to receive -1

//#################################################                      
#define RFInM 	  PINC.5	//              			
//#define TETest 	  PORTC.1	//
#define RFOut 	  PORTD.2	//						
//#define Switch	  PORTD.0       //PIN                           

//#define BtnT 	  PINB.7	// 
//#define BtnM 	  PINC.5	// 

#define BtnMode    PINC.2	//   
#define BtnTx      PINC.3	// 
#define BtnMem     PINC.4	//   		

#define LedR 	  PORTC.0	//     LedR-
#define LedG 	  PORTC.1	//
//#define LedB 	  PORTD.3	//

//#define LedM1 	  PORTC.3	//
//#define LedM2 	  PORTC.2	//
//#define LedM3 	  PORTC.1	//

#define Beeper 	  PORTD.3	//
//#define Vibro 	  PORTD.1	//
//#################################################

typedef unsigned char byte; // unsigned char  "byte"
//typedef unsigned int byte;      // one byte unsigned
typedef signed   int  sbyte;     // one byte signed
typedef signed   long word;      // one word signed

#pragma warn- //    
eeprom byte EprBuf0 [65];	// 0   
eeprom byte EprBuf1 [65];	// 1   
eeprom byte EprBuf2 [65];	//  2  - 

eeprom byte eep_ring;
#pragma warn+ //   

//int   TE_Test_CNT;

int   RFcount;           //  TE
int   BGRXcnt;                        
int   LastRxCnt;   
int   LedPulse;

int  NError;                             
//byte  ErrLength;

//byte  ErrLevel;

byte  BGRX;
byte  RFstate;   //  - 
byte  BitCount;          //   
//byte  L3FErCNT;

bit   ActiveBuf;         //   (         )
bit   RFFull;           //               
bit   TXFlag;           //         

//byte  ring;                                
byte  CellNo;      
byte  Grab; //  0,1     2 -   
byte  begin;

//bit   RFBitM;            //     
//bit   RFBitS;            //     

byte i;                 //  i     for

byte	    RxBuf   [65];   // /
byte	    RxBufLox[65];	//     

byte	    RxBuf1  [65];	//   1
byte	    RxBuf2  [65];	//   2

//   
#include "TX.c"             // 
#include "HDetect.c"           //         
#include "rx_code.c"           //         
#include "control.c"//  -    ...

// Declare your global variables here


// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=Out Func6=In Func7=In
// State0=P State1=P State2=P State3=0 State4=T State5=0 State6=T State7=T
PORTB=0x07;
DDRB=0x28;

// Port C initialization
// Func0=Out Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In
// State0=0 State1=0 State2=P State3=P State4=P State5=T State6=T
PORTC=0x1C;
DDRC=0x03;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=In Func5=In Func6=In Func7=In
// State0=0 State1=0 State2=0 State3=0 State4=T State5=T State6=T State7=T
PORTD=0x00;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x01;
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GICR|=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

		      LedR = 1;        //  
		      LedG = 1;
//****
/* if (BtnMode==0)  //   ""
    {             
    delay_ms(500);
    if (BtnMode==0)//  300ms   
       {                                         */
      
		for(i = 0; i != 10; i++)
		      {      
		      LedR = 1;        //  
		      LedG = 0;
		      delay_ms(50);    //  50ms
			  LedR = 0;        //s        
			  LedG = 1;
		      delay_ms(50);    //  50ms      
		      }                                       
		      LedG = 0;
		      Beep2();            
		
		Grab=1;//          
//		ring=eep_ring;

/*                 
Switch= 1;                              
 while (1)       //     
       {                
       RFOut=1;
       delay_ms(1);
       RFOut=0;
       delay_ms(1);
       }		
*/		
		// Global enable interrupts
		#asm("sei")  
  //     }               
   // }  

//***          




}
