//
//							 Software License Agreement
//
// The software supplied herewith by Microchip Technology Incorporated 
// (the "Company") for its PICmicro Microcontroller is intended and 
// supplied to you, the Companys customer, for use solely and 
// exclusively on Microchip PICmicro Microcontroller products. The 
// software is owned by the Company and/or its supplier, and is 
// protected under applicable copyright laws. All rights are reserved. 
//  Any use in violation of the foregoing restrictions may subject the 
// user to criminal sanctions under applicable laws, as well as to 
// civil liability for the breach of the terms and conditions of this 
// license.
//
// THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
// WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
// TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
// PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
// IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
// CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
//
//
//
//  Module DECHIT.h
//
//  include this file when using the HiTech C compiler
//
#define HITECH

#include <pic.h>
#include <string.h>

typedef unsigned char byte;
typedef signed char sbyte;
typedef signed int word;


#define TRUE    1
#define FALSE   0
#define ON      1
#define OFF     0

#define BIT_TEST( x, y) (( (x) & (1<<(y))) != 0)

// set config word
__CONFIG( UNPROTECT | (FOSC1 | FOSC0) | BODEN);  
__IDLOC(0x1234);                    // define ID locations 

