#include <mega8.h>    
#include <stdio.h>
#include <delay.h>
#include <String.h>   //      memcpy

//#define TRFreset    0   //  - ,    ,  
#define TRFSYNC     0   //  -  HEADER
#define TRFwait     2   //  -       
#define TRFError    3 
#define TRFError2    4   //  - 
#define TRFSkip     5   //  - 
#define TRFSkip2    6            

#define BGRX_Wait   0
#define BGRX_Run    1
#define BGRX_Zero   2
//#define BGRX_NoiseH 3
//#define BGRX_NoiseL 4

#define W           0
#define R           1

#define Cell_0      0
#define Cell_1      1
#define Cell_2      2

#define WrCell_0    0
#define WrCell_1    1
#define WrCell_2    2

#define TE           400        //

#define SHORT_HEAD   20         //   
#define LONG_HEAD    40         //   

#define NBIT         62     // number of bit to receive -1

//#################################################                      
#define RFInM 	  PINC.5	//              			
//#define TETest 	  PORTC.1	//
#define RFOut 	  PORTD.2	//						
//#define Switch	  PORTD.0       //PIN                           

//#define BtnT 	  PINB.7	// 
//#define BtnM 	  PINC.5	// 

#define BtnMode    PINC.2	//   
#define BtnTx      PINC.3	// 
#define BtnMem     PINC.4	//   		

#define LedR 	  PORTC.0	//     LedR-
#define LedG 	  PORTC.1	//
//#define LedB 	  PORTD.3	//

//#define LedM1 	  PORTC.3	//
//#define LedM2 	  PORTC.2	//
//#define LedM3 	  PORTC.1	//

#define Beeper 	  PORTD.3	//
//#define Vibro 	  PORTD.1	//
//#################################################

typedef unsigned char byte; // unsigned char  "byte"
//typedef unsigned int byte;      // one byte unsigned
typedef signed   int  sbyte;     // one byte signed
typedef signed   long word;      // one word signed

#pragma warn- //    
eeprom byte EprBuf0 [65];	// 0   
eeprom byte EprBuf1 [65];	// 1   
eeprom byte EprBuf2 [65];	//  2  - 

eeprom byte eep_ring;
#pragma warn+ //   

//int   TE_Test_CNT;

int   RFcount;           //  TE
int   BGRXcnt;                        
int   LastRxCnt;   
int   LedPulse;

int  NError;                             
//byte  ErrLength;

//byte  ErrLevel;

byte  BGRX;
byte  RFstate;   //  - 
byte  BitCount;          //   
//byte  L3FErCNT;

bit   ActiveBuf;         //   (         )
bit   RFFull;           //               
bit   TXFlag;           //         

//byte  ring;                                
byte  CellNo;      
byte  Grab; //  0,1     2 -   
byte  begin;

//bit   RFBitM;            //     
//bit   RFBitS;            //     

byte i;                 //  i     for

byte	    RxBuf   [65];   // /
byte	    RxBufLox[65];	//     

byte	    RxBuf1  [65];	//   1
byte	    RxBuf2  [65];	//   2

//   
#include "TX.c"             // 
void Beep2(void);
void Beep(void);
void SetActive (void);

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
byte SnCmpr(byte *TestBuf)
{//    
byte HOPcmp;    
//RFFull=1;

for (i = 32; i != 60; i ++)
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
  //     RFFull=0;  //   ,   
       return 0;  //   0
       }		                 
    }   

//***	

for (i = 0; i != 32; i ++) //  
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
       HOPcmp=1;      
       }		                 
    }      
    
if (!HOPcmp)      	
    return 0;

//***   	
		         
for (i = 60; i != 63; i ++) // 
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
       return 2;      
       }		                 
    }   
       	 
    	         		         
return 1;		         
} 
//-------------------------------------------------------------------------------------------------------------------------
//#########################################################################################################################

void TX (byte* TxBuf)
{           

BGRX    = BGRX_Wait;
RFstate = TRFwait;                 

//#asm("cli") 
LedR=1;
//Vibro=0; 
//Switch=1; // 
//========================================================================_Prambule	
//    24 :  =0  a=23,    1 
	for(i = 0; i != 31; i++)
       	{
       		RFOut = 0;
       		delay_us(TE);

       		RFOut = 1;       		
       		delay_us(TE); 
       	}
//========================================================================_HeaderTX
RFOut = 0;
delay_ms (4);
//========================================================================_BuffTX
//--------------------------------//1- 
//    
   
   for(i = 0; i != 66; i++) //
   {
    RFOut = 1;      
        
//    if (ring!=1)
        Beeper= 1;
        
    delay_us(TE);    
      
    RFOut=TxBuf[i];       
    delay_us(TE);

    RFOut = 0;    
    Beeper= 0;
    delay_us(TE);
   }  
    /*
    RFOut = 1;      
    delay_us(TE);    
      
    RFOut=0;       
    delay_us(TE);

    RFOut = 0;    
    delay_us(TE);
*/                  
    
//========================================================================_GuardTime                                                  
//Switch = 0;      //   =)
//Vibro=1; 
LedR=0;    
RFFull=0;
//#asm("sei") 
delay_ms (10);	//  15ms,       	 

RFstate = TRFSYNC;
}      


//#########################################################################################################################
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void BTNcomp(void) //   
{
if ((Grab>1 && SnCmpr(RxBufLox)==2) && Grab<4) //   - Grab = 1  //    
   {                                                                                                           
   Grab++;   
   if (ActiveBuf==0)//   Buf0(    )
      {
      ActiveBuf = 1;
      TX(RxBuf2); 
      Beep();
      TX(RxBuf2);
      }
  else//   Buf1(    ),   Buf0
      {            
      ActiveBuf = 0;
      TX(RxBuf1); 
      Beep();   
      TX(RxBuf1);
      }            
   }                           
   
//-----------------------------------------------------------------------------------------------------------------

if (Grab==1  && RFFull) //     ,    
   {                                                                     
   TX(RxBuf);    
   Beep();
   TX(RxBuf);       
   }
                                         
}  

//#########################################################################################################################


void SetActive (void)
{                                                       
if ( (SnCmpr(RxBuf1)==2 || SnCmpr(RxBuf2)==2) && begin >= 2 && Grab==0) 
// if ( (((SnCmpr(RxBuf1)==2) || (SnCmpr(RxBuf2)==2)) && (Grab!=2)) && (begin >= 2) && (Grab!=1)) 
    {          
    memcpy(RxBufLox,RxBuf, 65); //   LOX                 //         
    RFFull=1;
    LedG=1;         
    Grab=2;      
    Beep2();
    }                       
    
//--------------------------------------------------------------------------------------------------------

if (Grab<2 && ( SnCmpr(RxBuf1) || SnCmpr(RxBuf2) || begin<2 ) )                                                 //      
   {                                                    
   if (ActiveBuf==0)//   Buf0(    )
      {                                              
         ActiveBuf = 1;		//  Buf1                       
         memcpy(RxBuf2,RxBuf, 65); //   RxBuf2                          
         memcpy(RxBuf, RxBuf1,65); //  RxBuf1   
         RFFull=1;
      }
   else//   Buf1(    ),   Buf0
       {   
  	      ActiveBuf = 0;		//  Buf0      
	      memcpy(RxBuf1, RxBuf,65); //   RxBuf1     
	      memcpy(RxBuf, RxBuf2,65);//  RxBuf2         
	      RFFull=1;
       }        
   }    

}


#include "HDetect.c"           //         
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//interrupt [TIM0_OVF] void MainRecive(void) // ,   
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
//#############  +
TCNT0=135;
// - ,  - 
        
//LedG=0;
//LedR=0;
 
NError++;
/*      if (NError >= 50)
	 {          	           		   
	 NError = 0; 
	 if (RFstate == TRFSYNC)
            {
            Switch = 1;            
	    RFstate = TRFError;
//	    LedR   = 1;
	    RFOut  = 1;
	    
            BGRXcnt = 0;     
//          RFcount = 0;    
            }	 
	 } */

switch(RFstate)  //           
{
//************************************************

//************************************************
 case TRFError: //   ,  HEADER


// RFcount+10;      

/* delay_us(400);
 RFOut = 0;
 delay_us(50); 
 RFOut = 1;    
 delay_us(200);   */
        
// delay_us(150);   
 
 //RFcount=20;         
// LedR=0;
// LedG=0;        
 RFOut = 0;  
 RFstate = TRFError2; 
 
 break;

//************************************************

 case TRFError2: //   ,  HEADER     
                   
      RFOut = 1;
      RFstate = TRFSkip;
 
 break;
//************************************************ 

 case TRFSkip: //   ,  HEADER     
                   
      RFOut = 0;         
      //delay_us(100);
      RFstate = TRFSkip2; 
 
 break;                                             
 
 //************************************************ 

 case TRFSkip2: //   ,  HEADER     
                             
//      Switch = 0;        
      RFstate = TRFSYNC; 
 
 break;
//************************************************************************************************************************************

 case TRFwait://   
                                        
 //LedR=1;
 RFcount = 0; //          

 break;

//*************************************************
 case TRFSYNC: //                       
                             
 default:                                      
              
/*      if (NError >= 50)
	 {          	           		   
	 NError = 0;
         Switch = 1;   
         RFOut  = 1;            
	 RFstate = TRFError;  
	 }    */   
                      
 if (RFInM == 1)
    {            
    //LedG=1;
    
    
//     TETest=1; //               !!!        
     // rising edge detected  +---+                +---..
     //                       |   |  <-Theader->   |   
     //                           +----------------+                                                                
     BGRXcnt = 0;
     RFcount = 0;      	                                    
     BitCount= 0; 
     //L3FErCNT= 0;                                                             
     RFstate = TRFwait;                 
     BGRX = BGRX_Run;      
     //RFcount = 0; // HEADER-a  0
     //NError = 0;  //   0                     
    }
    
 else
     {      
     //LedR=1;
     
//     TETest=0; //               !!!         
     RFcount++; //  HEADER	          
     if (RFcount == 10)// && NError > 50 )
        {            
         NError = 0;
        // RFcount= 0;                                                        
         RFstate = TRFError; 	      
//         Switch= 1;	 
	 RFOut = 1; 
        }      
     }                

break;

//*************************************************************************************************************************************
       
    } // switch    */     
 
}
#include "rx_code.c"           //         
void RFError(void) //   
{
//Switch = 1; 
RFOut=1;

//if (ring!=1)
	for(i = 0; i != 10; i++)
	   {
	   Beeper=1;
	   delay_us(300);
	   Beeper=0; 
	   delay_us(150);	   
	   }    
 
RFOut=0; 
RFstate = TRFSYNC;
//Switch = 0; 
}


//***************************************************************

//BackGroundRecive
//interrupt [TIM0_OVF] void timer0_ovf_isr(void)
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{          
BGRXcnt++;


switch(BGRX)
      {
//#######################################################################################################################
//##############################################     ##################################################
//#######################################################################################################################

      case BGRX_Run:

	   if ( BGRXcnt == 8) // Optimal read-point for MASTER reciver  7,  10
	      {
//	      TETest=0; //              !!!
	      
	      if (RFFull == 0)
                 RxBuf[BitCount]=RFInM;     //   1/3 ,        

                 if (BitCount == 5 || BitCount == 10 || BitCount == 15 || BitCount == 20 || BitCount == 25 || BitCount == 30 || BitCount == 35 || BitCount == 40 || BitCount == 45)
                 //if (L3FErCNT >= 5 && BitCount > 5)
                    { 
                    //L3FErCNT=0;
                    //Switch = 1;
                    RFOut=1;
                    }

	      ++BitCount;
	      //++L3FErCNT;

              if (BitCount == 63) //   -
         	 {
         	 //Switch = 1;
//       	 Vibro=0;
         	 RxBuf[63]=1;
                 LastRxCnt=0;	      //    
                 TXFlag  = 1;

  		 if (RFFull == 0)   //     
 	            SetActive();      //  

         	 LedR=1;
                 BGRX    = BGRX_Wait; //   
   		 RFstate = TRFSYNC;
        	 RFError();
//   		 Vibro=1;

		 break;
    	         }
	      }

if ( BGRXcnt == 13)
   {
   RFOut=0;
   //Switch = 0;
   }


	   if (BGRXcnt == 15) // 13      16 //     
	      {              
	      if (RFInM == 1 && BitCount < 5)
	         {
	         //RFstate = TRFSYNC;
	         BGRX    = BGRX_Wait;
	         RFstate = TRFError;
	         }
	      
  	      //RFcount = 0;
	      BGRX    = BGRX_Zero; //
	      }

//          }      

      break;
     
     
//********************************************************************

      case BGRX_Wait:
      
      
      break;
           
//********************************************************************

      case BGRX_Zero:  
      default:
 
 if (RFInM == 1) //   
    {
//    TETest=1;                  //           !!!
    
     // rising edge detected     +----
     //                          |
     //                      ----+     
     BGRXcnt = 0;     
     //RFcount = 0;                // reset length count                  
     BGRX    = BGRX_Run; 
     break;        	             	         
     } 
  
    if (BGRXcnt > 35) //     10
       {       
       //RFcount=0;                          
       BGRX   = BGRX_Wait; 
       //RFstate = TRFSYNC;      
       RFstate = TRFError; // 
       }     
  
      break;

      }                                                      
}                     


#include "control.c"//  -    ...
//------------------- 
void Beep2(void)
{        
//Switch = 1; 
LedR=1;    
//Vibro=0;
RFOut=1;

for(i = 0; i != 250; i++)
   {
   Beeper=1;
   delay_us(150);
   Beeper=0;
   delay_us(150);
   }  
LedR=0;   
for(i = 0; i != 200; i++)
   {
   Beeper=1;
   delay_us(250);
   Beeper=0;
   delay_us(250);
   }   
LedR=1;   
for(i = 0; i != 150; i++)
   {
   Beeper=1;
   delay_us(350);
   Beeper=0;
   delay_us(350);
   }   

RFOut=0;      
//Vibro=1;   
LedR=0;
//Switch = 0; 
}

//************************************************************************************************

void RWCell(byte M)
{
switch (CellNo)
       {       
//-------------------------------------       
	    case Cell_0:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==R)
  		            RxBuf[i]   = EprBuf0[i];				                  		        
		        else   
		            EprBuf0[i] = RxBuf[i];
		         }
        break;
//------------------------------------- 
	    case Cell_1:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==R)
  		            RxBuf[i]   = EprBuf1[i];				                  		        
		        else   
		            EprBuf1[i] = RxBuf[i];
		         }
		break;
//------------------------------------- 
		case Cell_2:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==R)
  		            RxBuf[i]   = EprBuf2[i];				                  		        
		        else   
		            EprBuf2[i] = RxBuf[i];
		         } 
		break;
//-------------------------------------		
	   }  
	   	   
if (M==R) //     > RAM
   {
   TX(RxBuf);
   delay_ms(100);
   TX(RxBuf);
   }
else         
   {
   *RxBuf=0;
   *RxBuf1=0;
   *RxBuf2=0;
   }
    
Beep2();   
}

//************************************************************************************************

void Cell_Select(void)
{         
Beep();

if (CellNo == Cell_0)
   {
   CellNo   = Cell_1;
   delay_ms(100);
   Beep();   
   return;
   }

if (CellNo == Cell_1)
   {
   CellNo   = Cell_2;
   delay_ms(100);
   Beep();           
   delay_ms(100);
   Beep();
   return;
   }

if (CellNo == Cell_2)
   {
   CellNo   = Cell_0;
   return;
   }
      
}


//************************************************************************************************
//--------------------  ,      =)         
void Beep(void)
{          
//Switch = 1; 
RFOut=1;

//if (ring!=1)
	for(i = 0; i != 100; i++)
	   {
	   Beeper=1;
	   delay_us(200);
	   Beeper=0; 
	   delay_us(150);	   
	   }    
/*else
   {	   
   Vibro=0;   
   delay_ms(100);
   Vibro=1;   
   }*/
 
RFOut=0; 
//Switch = 0; 
}                                                                                                 

interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{            
LastRxCnt++; 
LedPulse++;          

if (LastRxCnt > 6000) //     50ms
   {
   LastRxCnt=0;  
   if (TXFlag)
      { 
      begin++;     
      BTNcomp(); //            	 
//      Vibro=1;    
      LedR=0;   
      RFFull=0;
      TXFlag=0;
      Beep();
      }                    
   }                 
   
       

//****   

if ( LedPulse>3000)
   {    
   if (Grab != 1)   
       LedG  = 1;
      
 /*  LedM1 = 1;
   LedM2 = 1;
   LedM3 = 1;  */
   }        
   
if ( LedPulse>4000)
   {   
	if (Grab < 2)   
	    LedG  = 0;    
	          
       /*	if (CellNo != Cell_0)   
	    LedM1 = 0;   
	if (CellNo != Cell_1)   
	    LedM2 = 0;   
	if (CellNo != Cell_2)   
	    LedM3 = 0;     */
   
	   LedPulse=0;
   } 
                             
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//byte GrabTMP;
//int BtnTime;             
//************************************************************************************************
//---------------------------------------------------------------- 
if (BtnTx==0) 
    delay_ms(50);

 if (BtnTx==0) 
    {             
    delay_ms(200);
    LedR=1;
    if (BtnTx==1)//  50ms 
       {                
       begin=0;    
       if (Grab==1)
          {
          RFFull=1;   
          begin=0;
          SetActive();  //  
          BTNcomp();    //  RAM         
          }           
      else             
          {
          Grab=0;                                    
          TX(RxBufLox); //  RAM                           
          delay_ms(200);          
          TX(RxBufLox);                          
//          LedG=0;                  
          }
       }   
   else
       {
       delay_ms(500);
       if (BtnTx==0)//  300ms  
          {
          RWCell(R);  //    EEPROM
          Cell_Select();
          }
       }
    LedR=0;        
    
    while (BtnTx==0) //   
          {
          delay_ms(10);                               
          }    
    }
        
//----------------------------------------------------------------                   

if (BtnMem==0) 
    delay_ms(50);

 if (BtnMem==0)  //   ""
    {           
//    BtnTime++;    
    delay_ms(200);
    if (BtnMem==1)//  50ms 
       {
       Cell_Select();            // 
       }
    else
        {
        delay_ms(500);
        if (BtnMem==0)//  300ms   
           {                                                                
           begin=0; 
                                                
           if (Grab>1)
              {       
              memcpy(RxBuf,RxBufLox, 65); //   LOX-                                          
              Grab=0;
              LedG=0;
              }
          else 
              {            
              SetActive();
              RFFull = 0;                             
              }
                                                                                                                      
           RWCell(W);             //   RxBuf-                                 
           Cell_Select();
           
  	       for (i = 0; i != 66; i ++)
		         {		         
  		         RxBuf [i] = 0;
  		         RxBuf1[i] = 0;
  		         RxBuf2[i] = 0;
		         }
                                 
           }  
           
    while (BtnMem==0) //   
          {
          delay_ms(10);
          }           
        }
   }    
  
//----------------------------------------------------------------  /             

if (BtnMode==0) 
    delay_ms(50);

 if (BtnMode==0)  //   ""
    {           
//    BtnTime++;    
    delay_ms(200);    
    LedR=1;                
    if (BtnMode==1)//  50ms 
       {       
       if (Grab != 1)//    
           Grab=1;
       else       
           Grab=0;
           
       Beep();    
       }
   else 
       {          
       LedR=1;
       delay_ms(500);
       if (BtnMode==0)//  300ms   
          {                                         
/*          ring=eep_ring;
          
          if (ring)    
             ring=0;                   
          else
             ring=1;
             
          eep_ring=ring;   */
                    
           Beep();
           Beep();
          }                 
       }           
    
    LedR=0;                        
    while (BtnMode==0) //   
          {
          delay_ms(10);
          }           

   }                   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

}




// Declare your global variables here


// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=Out Func6=In Func7=In
// State0=P State1=P State2=P State3=0 State4=T State5=0 State6=T State7=T
PORTB=0x07;
DDRB=0x28;

// Port C initialization
// Func0=Out Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In
// State0=0 State1=0 State2=P State3=P State4=P State5=T State6=T
PORTC=0x1C;
DDRC=0x03;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=In Func5=In Func6=In Func7=In
// State0=0 State1=0 State2=0 State3=0 State4=T State5=T State6=T State7=T
PORTD=0x00;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x01;
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GICR|=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

		      LedR = 1;        //  
		      LedG = 1;
//****
/* if (BtnMode==0)  //   ""
    {             
    delay_ms(500);
    if (BtnMode==0)//  300ms   
       {                                         */
      
		for(i = 0; i != 10; i++)
		      {      
		      LedR = 1;        //  
		      LedG = 0;
		      delay_ms(50);    //  50ms
			  LedR = 0;        //s        
			  LedG = 1;
		      delay_ms(50);    //  50ms      
		      }                                       
		      LedG = 0;
		      Beep2();            
		
		Grab=1;//          
//		ring=eep_ring;

/*                 
Switch= 1;                              
 while (1)       //     
       {                
       RFOut=1;
       delay_ms(1);
       RFOut=0;
       delay_ms(1);
       }		
*/		
		// Global enable interrupts
		#asm("sei")  
  //     }               
   // }  

//***          




}
